Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonCustom.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonCustom.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonCustom.pm	(revision 34921)
@@ -2295,17 +2762,17 @@
 sub ProcessCanonCustom($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $offset = $$dirInfo{DirStart};
     my $size = $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     # first entry in array must be the size
     my $len = Get16u($dataPt,$offset);
-    unless ($len == $size or ($$exifTool{Model}=~/\bD60\b/ and $len+2 == $size)) {
-        $exifTool->Warn("Invalid CanonCustom data");
+    unless ($len == $size or ($$et{Model}=~/\bD60\b/ and $len+2 == $size)) {
+        $et->Warn("Invalid CanonCustom data");
         return 0;
     }
-    $verbose and $exifTool->VerboseDir('CanonCustom', $size/2-1);
+    $verbose and $et->VerboseDir('CanonCustom', $size/2-1);
     my $pos;
     for ($pos=2; $pos<$size; $pos+=2) {
@@ -2314,5 +2781,5 @@
         my $tag = ($val >> 8);
         $val = ($val & 0xff);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $et->HandleTag($tagTablePtr, $tag, $val,
             Index  => $pos/2-1,
             Format => 'int8u',
@@ -2330,5 +2797,5 @@
 sub CheckCanonCustom($$$)
 {
-    my ($exifTool, $tagInfo, $valPtr) = @_;
+    my ($et, $tagInfo, $valPtr) = @_;
     return Image::ExifTool::CheckValue($valPtr, 'int8u');
 }
@@ -2340,6 +2807,6 @@
 sub WriteCanonCustom($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access to autoload this package
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access to autoload this package
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart} || 0;
@@ -2351,9 +2818,9 @@
     # first entry in array must be the size
     my $len = Get16u($dataPt, 0);
-    unless ($len == $dirLen or ($$exifTool{Model}=~/\bD60\b/ and $len+2 == $dirLen)) {
-        $exifTool->Warn("Invalid CanonCustom data");
+    unless ($len == $dirLen or ($$et{Model}=~/\bD60\b/ and $len+2 == $dirLen)) {
+        $et->Warn("Invalid CanonCustom data");
         return undef;
     }
-    my $newTags = $exifTool->GetNewTagInfoHash($tagTablePtr);
+    my $newTags = $et->GetNewTagInfoHash($tagTablePtr);
     my $pos;
     for ($pos=2; $pos<$dirLen; $pos+=2) {
@@ -2362,13 +2829,13 @@
         my $tagInfo = $$newTags{$tag};
         next unless $tagInfo;
-        my $nvHash = $exifTool->GetNewValueHash($tagInfo);
+        my $nvHash = $et->GetNewValueHash($tagInfo);
         $val = ($val & 0xff);
-        next unless Image::ExifTool::IsOverwriting($nvHash, $val);
-        my $newVal = Image::ExifTool::GetNewValues($nvHash);
+        next unless $et->IsOverwriting($nvHash, $val);
+        my $newVal = $et->GetNewValue($nvHash);
         next unless defined $newVal;    # can't delete from a custom table
         Set16u(($newVal & 0xff) + ($tag << 8), $dataPt, $pos);
-        $exifTool->VerboseValue("- $dirName:$$tagInfo{Name}", $val);
-        $exifTool->VerboseValue("+ $dirName:$$tagInfo{Name}", $newVal);
-        ++$exifTool->{CHANGED};
+        $et->VerboseValue("- $dirName:$$tagInfo{Name}", $val);
+        $et->VerboseValue("+ $dirName:$$tagInfo{Name}", $newVal);
+        ++$$et{CHANGED};
     }
     return $newData;
@@ -2397,5 +2864,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonRaw.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonRaw.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonRaw.pm	(revision 34921)
@@ -7,5 +7,4 @@
 #               12/02/2003 - P. Harvey Completely reworked and figured out many
 #                            more tags
-#               01/19/2004 - P. Harvey Added CleanRaw()
 #
 # References:   1) http://www.cybercom.net/~dcoffin/dcraw/
@@ -23,5 +22,5 @@
 use Image::ExifTool::Canon;
 
-$VERSION = '1.54';
+$VERSION = '1.58';
 
 sub WriteCRW($$);
@@ -76,7 +75,5 @@
         Name => 'CanonRawMakeModel',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::CanonRaw::MakeModel',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonRaw::MakeModel' },
     },
     0x080b => { Name => 'CanonFirmwareVersion', Writable => 'string[32]' },
@@ -122,14 +119,10 @@
         Name => 'CanonFocalLength',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::FocalLength',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::FocalLength' },
     },
     0x102a => {
         Name => 'CanonShotInfo',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::ShotInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ShotInfo' },
     },
     0x102c => {
@@ -144,7 +137,5 @@
         Name => 'CanonCameraSettings',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CameraSettings',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::CameraSettings' },
     },
     0x1030 => { #4
@@ -159,7 +150,5 @@
         Name => 'SensorInfo',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::SensorInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::SensorInfo' },
     },
     # this tag has only be verified for the 10D in CRW files, but the D30 and D60
@@ -203,7 +192,5 @@
         Name => 'CanonAFInfo',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::AFInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::AFInfo' },
     },
     0x1093 => {
@@ -217,10 +204,5 @@
         Name => 'ColorBalance',
         Writable => 0,
-        SubDirectory => {
-            # this offset is necessary because the table contains short rationals
-            # (4 bytes long) but the first entry is 2 bytes into the table.
-            Start => '2',
-            TagTable => 'Image::ExifTool::Canon::ColorBalance',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::ColorBalance' },
     },
     0x10b5 => { #PH
@@ -247,7 +229,5 @@
         Name => 'ImageFormat',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::CanonRaw::ImageFormat',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonRaw::ImageFormat' },
     },
     0x1804 => { Name => 'RecordID', Writable => 'int32u' }, #3
@@ -332,7 +312,5 @@
         Groups => { 1 => 'CIFF' }, # (only so CIFF shows up in group lists)
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::CanonRaw::ExposureInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonRaw::ExposureInfo' },
     },
     0x1834 => { #PH
@@ -350,7 +328,5 @@
         Name => 'DecoderTable',
         Writable => 0,
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::CanonRaw::DecoderTable',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonRaw::DecoderTable' },
     },
     0x183b => { #PH
@@ -371,4 +347,5 @@
     0x2007 => {
         Name => 'JpgFromRaw',
+        Groups => { 2 => 'Preview' },
         Writable => 'resize',  # 'resize' allows this value to change size
         Permanent => 0,
@@ -377,4 +354,5 @@
     0x2008 => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         Writable => 'resize',  # 'resize' allows this value to change size
         WriteCheck => '$self->CheckImage(\$val)',
@@ -636,11 +614,11 @@
 sub ProcessCanonRaw($$$)
 {
-    my ($exifTool, $dirInfo, $rawTagTable) = @_;
+    my ($et, $dirInfo, $rawTagTable) = @_;
     my $blockStart = $$dirInfo{DirStart};
     my $blockSize = $$dirInfo{DirLen};
     my $raf = $$dirInfo{RAF} or return 0;
     my $buff;
-    my $verbose = $exifTool->Options('Verbose');
-    my $buildMakerNotes = $exifTool->Options('MakerNotes');
+    my $verbose = $et->Options('Verbose');
+    my $buildMakerNotes = $et->Options('MakerNotes');
 
     # 4 bytes at end of block give directory position within block
@@ -654,5 +632,5 @@
     $raf->Read($buff, 10 * $entries) == 10 * $entries or return 0;
 
-    $verbose and $exifTool->VerboseDir('CIFF', $entries);
+    $verbose and $et->VerboseDir('CIFF', $entries);
     my $index;
     for ($index=0; $index<$entries; ++$index) {
@@ -663,5 +641,5 @@
         my $ptr = $valuePtr + $blockStart;  # all pointers relative to block start
         if ($tag & 0x8000) {
-            $exifTool->Warn('Bad CRW directory entry');
+            $et->Warn('Bad CRW directory entry');
             return 1;
         }
@@ -669,5 +647,5 @@
         my $tagType = ($tag >> 8) & 0x38;   # get tag type
         my $valueInDir = ($tag & 0x4000);   # flag for value in directory
-        my $tagInfo = $exifTool->GetTagInfo($rawTagTable, $tagID);
+        my $tagInfo = $et->GetTagInfo($rawTagTable, $tagID);
         if (($tagType==0x28 or $tagType==0x30) and not $valueInDir) {
             # this type of tag specifies a raw subdirectory
@@ -686,5 +664,5 @@
             if ($verbose) {
                 my $fakeInfo = { Name => $name, SubDirectory => { } };
-                $exifTool->VerboseInfo($tagID, $fakeInfo,
+                $et->VerboseInfo($tagID, $fakeInfo,
                     'Index'  => $index,
                     'Size'   => $size,
@@ -692,5 +670,5 @@
                 );
             }
-            $exifTool->ProcessDirectory(\%subdirInfo, $rawTagTable);
+            $et->ProcessDirectory(\%subdirInfo, $rawTagTable);
             next;
         }
@@ -706,5 +684,5 @@
         if ($valueInDir) {  # is the value data in the directory?
             # this type of tag stores the value in the 'size' and 'ptr' fields
-            $valueDataPos = $dirOffset + $pt + 4;
+            $valueDataPos = $dirOffset + $pt + 4; # (remember, +2 for the entry count)
             $size = 8;
             $value = substr($buff, $pt+2, $size);
@@ -716,10 +694,10 @@
             if ($size <= 512 or ($verbose > 2 and $size <= 65536)
                 or ($tagInfo and ($$tagInfo{SubDirectory}
-                or grep(/^$$tagInfo{Name}$/i, $exifTool->GetRequestedTags()) )))
+                or grep(/^$$tagInfo{Name}$/i, $et->GetRequestedTags()) )))
             {
                 # read value if size is small or specifically requested
                 # or if this is a SubDirectory
                 unless ($raf->Seek($ptr, 0) and $raf->Read($value, $size) == $size) {
-                    $exifTool->Warn(sprintf("Error reading %d bytes from 0x%x",$size,$ptr));
+                    $et->Warn(sprintf("Error reading %d bytes from 0x%x",$size,$ptr));
                     next;
                 }
@@ -727,8 +705,8 @@
                 $value = "Binary data $size bytes";
                 if ($tagInfo) {
-                    if ($exifTool->Options('Binary') or $verbose) {
+                    if ($et->Options('Binary') or $verbose) {
                         # read the value anyway
                         unless ($raf->Seek($ptr, 0) and $raf->Read($value, $size) == $size) {
-                            $exifTool->Warn(sprintf("Error reading %d bytes from 0x%x",$size,$ptr));
+                            $et->Warn(sprintf("Error reading %d bytes from 0x%x",$size,$ptr));
                             next;
                         }
@@ -752,5 +730,5 @@
             my $val = $value;
             $format and $val = ReadValue(\$val, 0, $format, $count, $size);
-            $exifTool->VerboseInfo($tagID, $tagInfo,
+            $et->VerboseInfo($tagID, $tagInfo,
                 Table   => $rawTagTable,
                 Index   => $index,
@@ -765,5 +743,5 @@
         if ($buildMakerNotes) {
             # build maker notes information if requested
-            BuildMakerNotes($exifTool, $tagID, $tagInfo, \$value, $format, $count);
+            BuildMakerNotes($et, $tagID, $tagInfo, \$value, $format, $count);
         }
         next unless defined $tagInfo;
@@ -795,11 +773,12 @@
                 Nesting  => $$dirInfo{Nesting} + 1,
                 RAF      => $raf,
+                DirName  => $name,
                 Parent   => $$dirInfo{DirName},
             );
             #### eval Validate ($dirData, $subdirStart, $size)
             if (defined $$subdir{Validate} and not eval $$subdir{Validate}) {
-                $exifTool->Warn("Invalid $name data");
+                $et->Warn("Invalid $name data");
             } else {
-                $exifTool->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
+                $et->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
             }
         } else {
@@ -807,5 +786,5 @@
             $format and $value = ReadValue(\$value, 0, $format, $count, $size);
             # save the information
-            $exifTool->FoundTag($tagInfo, $value);
+            $et->FoundTag($tagInfo, $value);
             delete $$tagInfo{RawConv} if $delRawConv;
         }
@@ -820,8 +799,8 @@
 sub ProcessCRW($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my ($buff, $sig);
     my $raf = $$dirInfo{RAF};
-    my $buildMakerNotes = $exifTool->Options('MakerNotes');
+    my $buildMakerNotes = $et->Options('MakerNotes');
 
     $raf->Read($buff,2) == 2      or return 0;
@@ -836,8 +815,8 @@
 
     # initialize maker note data if building maker notes
-    $buildMakerNotes and InitMakerNotes($exifTool);
-
-    # set the FileType tag unless already done (ie. APP0 CIFF record in JPEG image)
-    $exifTool->SetFileType();
+    $buildMakerNotes and InitMakerNotes($et);
+
+    # set the FileType tag unless already done (eg. APP0 CIFF record in JPEG image)
+    $et->SetFileType();
 
     # build directory information for main raw directory
@@ -853,15 +832,18 @@
     # process the raw directory
     my $rawTagTable = GetTagTable('Image::ExifTool::CanonRaw::Main');
-    unless ($exifTool->ProcessDirectory(\%dirInfo, $rawTagTable)) {
-        $exifTool->Warn('CRW file format error');
+    my $oldIndent = $$et{INDENT};
+    $$et{INDENT} .= '| ';
+    unless (ProcessCanonRaw($et, \%dirInfo, $rawTagTable)) {
+        $et->Warn('CRW file format error');
     }
+    $$et{INDENT} = $oldIndent;
 
     # finish building maker notes if necessary
-    $buildMakerNotes and SaveMakerNotes($exifTool);
+    $buildMakerNotes and SaveMakerNotes($et);
 
     # process trailers if they exist in CRW file (not in CIFF information!)
-    if ($$exifTool{FILE_TYPE} eq 'CRW') {
+    if ($$et{FILE_TYPE} eq 'CRW') {
         my $trailInfo = Image::ExifTool::IdentifyTrailer($raf);
-        $exifTool->ProcessTrailers($trailInfo) if $trailInfo;
+        $et->ProcessTrailers($trailInfo) if $trailInfo;
     }
 
@@ -896,5 +878,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -911,5 +893,5 @@
 =item L<http://xyrion.org/ciff/>
 
-=item L<http://owl.phy.queensu.ca/~phil/exiftool/canon_raw.html>
+=item L<https://exiftool.org/canon_raw.html>
 
 =back
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34921)
@@ -2,5 +2,5 @@
 # File:         CanonVRD.pm
 #
-# Description:  Read/write Canon VRD information
+# Description:  Read/write Canon VRD and DR4 information
 #
 # Revisions:    2006/10/30 - P. Harvey Created
@@ -10,7 +10,9 @@
 #               2010/06/18 - PH Support variable-length CustomPictureStyle data
 #               2010/09/14 - PH Added r/w support for XMP in VRD
+#               2015/05/16 - PH Added DR4 support (DPP 4.1.50.0)
+#               2018/03/13 - PH Update to DPP 4.8.20
 #
 # References:   1) Bogdan private communication (Canon DPP v3.4.1.1)
-#               2) Gert Kello private communiation (DPP 3.8)
+#               2) Gert Kello private communication (DPP 3.8)
 #------------------------------------------------------------------------------
 
@@ -20,6 +22,7 @@
 use vars qw($VERSION);
 use Image::ExifTool qw(:DataAccess :Utils);
-
-$VERSION = '1.12';
+use Image::ExifTool::Canon;
+
+$VERSION = '1.33';
 
 sub ProcessCanonVRD($$;$);
@@ -28,4 +31,6 @@
 sub ProcessIHL($$$);
 sub ProcessIHLExif($$$);
+sub ProcessDR4($$;$);
+sub SortDR4($$);
 
 # map for adding directories to VRD
@@ -35,5 +40,25 @@
 );
 
-my %noYes = ( 0 => 'No', 1 => 'Yes' );
+my %noYes = (
+    PrintConvColumns => 2,
+    PrintConv => { 0 => 'No', 1 => 'Yes' },
+);
+
+# DR4 format codes
+my %vrdFormat = (
+    1 => 'int32u',
+    2 => 'string',
+    8 => 'int32u',
+    9 => 'int32s',
+    13 => 'double',
+    33 => 'int32u', # (array)
+    38 => 'double', # (array)
+    # 254 => 'undef', ?
+    255 => 'undef',
+);
+
+# empty VRD header/footer for creating VRD from scratch
+my $blankHeader = "CANON OPTIONAL DATA\0\0\x01\0\0\0\0\0\0";
+my $blankFooter = "CANON OPTIONAL DATA\0" . ("\0" x 42) . "\xff\xd9";
 
 # main tag table blocks in CanonVRD trailer (ref PH)
@@ -43,9 +68,9 @@
     NOTES => q{
         Canon Digital Photo Professional writes VRD (Recipe Data) information as a
-        trailer record to JPEG, TIFF, CRW and CR2 images, or as a stand-alone VRD
-        file.  The tags listed below represent information found in this record. 
-        The complete VRD data record may be accessed as a block using the Extra
-        'CanonVRD' tag, but this tag is not extracted or copied unless specified
-        explicitly.
+        trailer record to JPEG, TIFF, CRW and CR2 images, or as stand-alone VRD or
+        DR4 files.  The tags listed below represent information found in these
+        records.  The complete VRD/DR4 data record may be accessed as a block using
+        the Extra 'CanonVRD' or 'CanonDR4' tag, but this tag is not extracted or
+        copied unless specified explicitly.
     },
     0xffff00f4 => {
@@ -65,4 +90,8 @@
             TagTable => 'Image::ExifTool::XMP::Main',
         },
+    },
+    0xffff00f7 => {
+        Name => 'Edit4Data',
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::Edit4' },
     },
 );
@@ -81,5 +110,4 @@
     1 => {
         Name => 'VRDStampTool',
-        # (size is variable, and obtained from int32u at end of last directory)
         Size => 0,      # size is variable, and obtained from int32u at directory start
         SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::StampTool' },
@@ -89,4 +117,17 @@
         Size => undef,  # size is the remaining edit data
         SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::Ver2' },
+    },
+);
+
+# Canon DPP version 4 edit information
+%Image::ExifTool::CanonVRD::Edit4 = (
+    WRITE_PROC => \&ProcessEditData,
+    PROCESS_PROC => \&ProcessEditData,
+    VARS => { ID_LABEL => 'Index' }, # change TagID label in documentation
+    NOTES => 'Canon DPP version 4 edit information.',
+    0 => {
+        Name => 'DR4',
+        Size => undef,  # size is the remaining edit data
+        SubDirectory => { TagTable => 'Image::ExifTool::CanonVRD::DR4' },
     },
 );
@@ -110,6 +151,6 @@
             Name => 'IHL_EXIF',
             Notes => q{
-                extracted as a block if the Unknown option is used, or processed as the
-                first sub-document with the ExtractEmbedded option
+                extracted as a block if the L<Unknown|../ExifTool.html#Unknown> option is used, or processed as the
+                first sub-document with the L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option
             },
             Binary => 1,
@@ -122,13 +163,15 @@
         # (same size as the PreviewImage with DPP 3.0.2.6)
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
     4 => {
         Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
         Binary => 1,
     },
     5 => {
         Name => 'RawCodecVersion',
-        ValueConv => '$val =~ s/\0.*//; $val',  # truncate string at null
+        ValueConv => '$val =~ s/\0.*//s; $val',  # truncate string at null
     },
     6 => {
@@ -157,14 +200,14 @@
         DataMember => 'VRDVersion',
         RawConv => '$$self{VRDVersion} = $val',
-        PrintConv => 'sprintf("%.2f", $val / 100)',
-    },
-    # 0x006 related somehow to RGB levels
-    0x008 => {
-        Name => 'WBAdjRGBLevels',
-        Format => 'int16u[3]',
+        PrintConv => '$val =~ s/^(\d)(\d*)(\d)$/$1.$2.$3/; $val',
+    },
+    0x006 => {
+        Name => 'WBAdjRGGBLevels',
+        Format => 'int16u[4]',
     },
     0x018 => {
         Name => 'WhiteBalanceAdj',
         Format => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Auto',
@@ -185,9 +228,8 @@
     },
     # 0x01c similar to 0x006
-    # 0x01e similar to 0x008
     0x024 => {
         Name => 'WBFineTuneActive',
         Format => 'int16u',
-        PrintConv => \%noYes,
+        %noYes,
     },
     0x028 => {
@@ -227,4 +269,5 @@
         Name => 'ToneCurveProperty',
         Format => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Shot Settings',
@@ -253,5 +296,5 @@
         Name => 'ToneCurveActive',
         Format => 'int16u',
-        PrintConv => \%noYes,
+        %noYes,
     },
     0x113 => {
@@ -338,5 +381,5 @@
         Name => 'CropActive',
         Format => 'int16u',
-        PrintConv => \%noYes,
+        %noYes,
     },
     0x246 => {
@@ -377,4 +420,6 @@
             10 => '5:4',
             11 => '1:1',
+            12 => 'Circle',
+            65535 => 'Custom',
         },
     },
@@ -422,5 +467,5 @@
         },
     },
-    # (VRD 1.0 edit data ends here -- 0x272 bytes)
+    # (VRD 1.0.0 edit data ends here -- 0x272 bytes)
 );
 
@@ -443,9 +488,11 @@
     FIRST_ENTRY => 0,
     FORMAT => 'int16s',
-    DATAMEMBER => [ 0x58 ], # (required for writable var-format tags)
+    DATAMEMBER => [ 0x58, 0xdc, 0xdf, 0xe0 ], # (required for DataMember and var-format tags)
+    IS_SUBDIR => [ 0xe0 ],
     GROUPS => { 2 => 'Image' },
     NOTES => 'Tags added in DPP version 2.0 and later.',
     0x02 => {
         Name => 'PictureStyle',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Standard',
@@ -459,15 +506,14 @@
         },
     },
-    0x03 => {
-        Name => 'IsCustomPictureStyle',
-        PrintConv => \%noYes,
-    },
+    0x03 => { Name => 'IsCustomPictureStyle', %noYes },
+    # 0x08: 3
+    # 0x09: 4095
+    # 0x0a: 0
+    # 0x0b: 4095
+    # 0x0c: 0
     0x0d => 'StandardRawColorTone',
     0x0e => 'StandardRawSaturation',
     0x0f => 'StandardRawContrast',
-    0x10 => {
-        Name => 'StandardRawLinear',
-        PrintConv => \%noYes,
-    },
+    0x10 => { Name => 'StandardRawLinear', %noYes },
     0x11 => 'StandardRawSharpness',
     0x12 => 'StandardRawHighlightPoint',
@@ -478,8 +524,5 @@
     0x17 => 'PortraitRawSaturation',
     0x18 => 'PortraitRawContrast',
-    0x19 => {
-        Name => 'PortraitRawLinear',
-        PrintConv => \%noYes,
-    },
+    0x19 => { Name => 'PortraitRawLinear', %noYes },
     0x1a => 'PortraitRawSharpness',
     0x1b => 'PortraitRawHighlightPoint',
@@ -490,8 +533,5 @@
     0x20 => 'LandscapeRawSaturation',
     0x21 => 'LandscapeRawContrast',
-    0x22 => {
-        Name => 'LandscapeRawLinear',
-        PrintConv => \%noYes,
-    },
+    0x22 => { Name => 'LandscapeRawLinear', %noYes },
     0x23 => 'LandscapeRawSharpness',
     0x24 => 'LandscapeRawHighlightPoint',
@@ -502,8 +542,5 @@
     0x29 => 'NeutralRawSaturation',
     0x2a => 'NeutralRawContrast',
-    0x2b => {
-        Name => 'NeutralRawLinear',
-        PrintConv => \%noYes,
-    },
+    0x2b => { Name => 'NeutralRawLinear', %noYes },
     0x2c => 'NeutralRawSharpness',
     0x2d => 'NeutralRawHighlightPoint',
@@ -514,8 +551,5 @@
     0x32 => 'FaithfulRawSaturation',
     0x33 => 'FaithfulRawContrast',
-    0x34 => {
-        Name => 'FaithfulRawLinear',
-        PrintConv => \%noYes,
-    },
+    0x34 => { Name => 'FaithfulRawLinear', %noYes },
     0x35 => 'FaithfulRawSharpness',
     0x36 => 'FaithfulRawHighlightPoint',
@@ -544,8 +578,5 @@
     },
     0x3c => 'MonochromeContrast',
-    0x3d => {
-        Name => 'MonochromeLinear',
-        PrintConv => \%noYes,
-    },
+    0x3d => { Name => 'MonochromeLinear', %noYes },
     0x3e => 'MonochromeSharpness',
     0x3f => 'MonochromeRawHighlightPoint',
@@ -554,9 +585,5 @@
     0x42 => 'MonochromeOutputShadowPoint',
     0x45 => { Name => 'UnknownContrast',            Unknown => 1 },
-    0x46 => {
-        Name => 'UnknownLinear',
-        Unknown => 1,
-        PrintConv => \%noYes,
-    },
+    0x46 => { Name => 'UnknownLinear', %noYes,      Unknown => 1 },
     0x47 => { Name => 'UnknownSharpness',           Unknown => 1 },
     0x48 => { Name => 'UnknownRawHighlightPoint',   Unknown => 1 },
@@ -564,9 +591,8 @@
     0x4a => { Name => 'UnknownOutputHighlightPoint',Unknown => 1 },
     0x4b => { Name => 'UnknownOutputShadowPoint',   Unknown => 1 },
+    0x4c => 'CustomColorTone',
+    0x4d => 'CustomSaturation',
     0x4e => 'CustomContrast',
-    0x4f => {
-        Name => 'CustomLinear',
-        PrintConv => \%noYes,
-    },
+    0x4f => { Name => 'CustomLinear', %noYes },
     0x50 => 'CustomSharpness',
     0x51 => 'CustomRawHighlightPoint',
@@ -582,9 +608,9 @@
         RawConv => 'length($val) == 2 ? undef : $val', # ignore if no data
     },
-    # (VRD 2.0 edit data ends here: 178 bytes, index 0x59)
+    # (VRD 2.0.0 edit data ends here: 178 bytes, index 0x59)
     0x5e => [{
         Name => 'ChrominanceNoiseReduction',
         Condition => '$$self{VRDVersion} < 330',
-        Notes => 'VRDVersion prior to 3.30',
+        Notes => 'VRDVersion prior to 3.3.0',
         PrintConv => {
             0   => 'Off',
@@ -594,5 +620,5 @@
     },{ #1
         Name => 'ChrominanceNoiseReduction',
-        Notes => 'VRDVersion 3.30 or later',
+        Notes => 'VRDVersion 3.3.0 or later',
         PrintHex => 1,
         PrintConvColumns => 4,
@@ -624,5 +650,5 @@
         Name => 'LuminanceNoiseReduction',
         Condition => '$$self{VRDVersion} < 330',
-        Notes => 'VRDVersion prior to 3.30',
+        Notes => 'VRDVersion prior to 3.3.0',
         PrintConv => {
             0   => 'Off',
@@ -632,5 +658,5 @@
     },{ #1
         Name => 'LuminanceNoiseReduction',
-        Notes => 'VRDVersion 3.30 or later',
+        Notes => 'VRDVersion 3.3.0 or later',
         PrintHex => 1,
         PrintConvColumns => 4,
@@ -662,5 +688,5 @@
         Name => 'ChrominanceNR_TIFF_JPEG',
         Condition => '$$self{VRDVersion} < 330',
-        Notes => 'VRDVersion prior to 3.30',
+        Notes => 'VRDVersion prior to 3.3.0',
         PrintConv => {
             0   => 'Off',
@@ -670,5 +696,5 @@
     },{ #1
         Name => 'ChrominanceNR_TIFF_JPEG',
-        Notes => 'VRDVersion 3.30 or later',
+        Notes => 'VRDVersion 3.3.0 or later',
         PrintHex => 1,
         PrintConvColumns => 4,
@@ -697,21 +723,10 @@
         },
     }],
-    # (VRD 3.0 edit data ends here: 196 bytes, index 0x62)
-    0x62 => {
-        Name => 'ChromaticAberrationOn',
-        ValueConv => \%noYes,
-    },
-    0x63 => {
-        Name => 'DistortionCorrectionOn',
-        ValueConv => \%noYes,
-    },
-    0x64 => {
-        Name => 'PeripheralIlluminationOn',
-        ValueConv => \%noYes,
-    },
-    0x65 => {
-        Name => 'ColorBlur',
-        ValueConv => \%noYes,
-    },
+    # 0x61: 1
+    # (VRD 3.0.0 edit data ends here: 196 bytes, index 0x62)
+    0x62 => { Name => 'ChromaticAberrationOn',      %noYes },
+    0x63 => { Name => 'DistortionCorrectionOn',     %noYes },
+    0x64 => { Name => 'PeripheralIlluminationOn',   %noYes },
+    0x65 => { Name => 'ColorBlur',                  %noYes },
     0x66 => {
         Name => 'ChromaticAberration',
@@ -752,9 +767,6 @@
         ValueConvInv => 'int($val * 10 + 0.5)',
     },
-    # (VRD 3.4 edit data ends here: 220 bytes, index 0x6e)
-    0x6e => {
-        Name => 'AutoLightingOptimizerOn',
-        PrintConv => \%noYes,
-    },
+    # (VRD 3.4.0 edit data ends here: 220 bytes, index 0x6e)
+    0x6e => { Name => 'AutoLightingOptimizerOn', %noYes },
     0x6f => {
         Name => 'AutoLightingOptimizer',
@@ -766,5 +778,7 @@
         },
     },
-    # (VRD 3.5 edit data ends here: 232 bytes, index 0x74)
+    # 0x71: 200
+    # 0x73: 100
+    # (VRD 3.5.0 edit data ends here: 232 bytes, index 0x74)
     0x75 => {
         Name => 'StandardRawHighlight',
@@ -858,4 +872,5 @@
         Name => 'CheckMark2',
         Format => 'int16u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Clear',
